org.apache.lucene.document

## Class Document

- java.lang.Object
- - org.apache.lucene.document.Document

- All Implemented Interfaces:
    Iterable<IndexableField>

      public final class Document
      extends Object
      implements Iterable<IndexableField>

  Documents are the unit of indexing and search. A Document is a set of fields. Each field has a name and a textual value. A field may be `stored` with the document, in which case it is returned with search hits on the document. Thus each document should typically contain one or more stored fields which uniquely identify it.

  Note that fields which are not `stored` are not available in documents retrieved from the index, e.g. with `ScoreDoc.doc` or `IndexReader.document(int)`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Document()` Constructs a new document with no fields.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(IndexableField field)` Adds a field to a document.
    `String` | `get(String name)` Returns the string value of the field with the given name if any exist in this document, or null.
    `BytesRef` | `getBinaryValue(String name)` Returns an array of bytes for the first (or only) field that has the name specified as the method parameter.
    `BytesRef[]` | `getBinaryValues(String name)` Returns an array of byte arrays for of the fields that have the name specified as the method parameter.
    `IndexableField` | `getField(String name)` Returns a field with the given name if any exist in this document, or null.
    `List<IndexableField>` | `getFields()` Returns a List of all the fields in a document.
    `IndexableField[]` | `getFields(String name)` Returns an array of `IndexableField`s with the given name.
    `String[]` | `getValues(String name)` Returns an array of values of the field specified as the method parameter.
    `Iterator<IndexableField>` | `iterator()`
    `void` | `removeField(String name)` Removes field with the specified name from the document.
    `void` | `removeFields(String name)` Removes all fields with the given name from the document.
    `String` | `toString()` Prints the fields of a document for human consumption.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Document

          public Document()

      Constructs a new document with no fields.

  - ### Method Detail

    - #### iterator

          public Iterator<IndexableField> iterator()

      Specified by:
        `iterator` in interface `Iterable<IndexableField>`

    - #### add

          public final void add(IndexableField field)

      Adds a field to a document. Several fields may be added with the same name. In this case, if the fields are indexed, their text is treated as though appended for the purposes of search.

      Note that add like the removeField(s) methods only makes sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

    - #### removeField

          public final void removeField(String name)

      Removes field with the specified name from the document. If multiple fields exist with this name, this method removes the first field that has been added. If there is no field with the specified name, the document remains unchanged.

      Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

    - #### removeFields

          public final void removeFields(String name)

      Removes all fields with the given name from the document. If there is no field with the specified name, the document remains unchanged.

      Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

    - #### getBinaryValues

          public final BytesRef[] getBinaryValues(String name)

      Returns an array of byte arrays for of the fields that have the name specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null.
      Parameters:
        `name` - the name of the field
      Returns:
        a `BytesRef[]` of binary field values

    - #### getBinaryValue

          public final BytesRef getBinaryValue(String name)

      Returns an array of bytes for the first (or only) field that has the name specified as the method parameter. This method will return `null` if no binary fields with the specified name are available. There may be non-binary fields with the same name.
      Parameters:
        `name` - the name of the field.
      Returns:
        a `BytesRef` containing the binary field value or `null`

    - #### getField

          public final IndexableField getField(String name)

      Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added.

    - #### getFields

          public IndexableField[] getFields(String name)

      Returns an array of `IndexableField`s with the given name. This method returns an empty array when there are no matching fields. It never returns null.
      Parameters:
        `name` - the name of the field
      Returns:
        a `IndexableField[]` array

    - #### getFields

          public final List<IndexableField> getFields()

      Returns a List of all the fields in a document.

      Note that fields which are not stored are not available in documents retrieved from the index, e.g. `IndexSearcher.doc(int)` or `IndexReader.document(int)`.

    - #### getValues

          public final String[] getValues(String name)

      Returns an array of values of the field specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null. For `IntField`, `LongField`, `FloatField` and `DoubleField` it returns the string value of the number. If you want the actual numeric field instances back, use `getFields(java.lang.String)`.
      Parameters:
        `name` - the name of the field
      Returns:
        a `String[]` of field values

    - #### get

          public final String get(String name)

      Returns the string value of the field with the given name if any exist in this document, or null. If multiple fields exist with this name, this method returns the first value added. If only binary fields with this name exist, returns null. For `IntField`, `LongField`, `FloatField` and `DoubleField` it returns the string value of the number. If you want the actual numeric field instance back, use `getField(java.lang.String)`.

    - #### toString

          public final String toString()

      Prints the fields of a document for human consumption.
      Overrides:
        `toString` in class `Object`

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.